;Ejemplo con el 12F629
;Este programa enciende un LED cada vez que se oprime un pulsador


         list      p=12F629            
	     #include <p12F629.inc> 

;-------------------------------------------------------------------------------
	errorlevel  -302           
    __CONFIG   _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT  

;-------------------------------------------------------------------------------
;  Registros
;-------------------------------------------------------------------------------
      CBLOCK 0x20
           x1,x2,x3,x4,loops,loops2			
      endc

#define   pulsador		GPIO,3	

       	  org       0x000			
          goto      inicio

          org	    0x005	         

inicio   

;******************************************************************************
	  bsf     STATUS,RP0		 
	  movwf   OSCCAL		 
 	  movlw	  B'000001000'		
	  movwf	  TRISIO			
	  bcf     STATUS,RP0		
;******************************************************************************
	  clrf	   GPIO
	  movlw    0xff
	  movwf	   GPIO
	  call	   retardo
	  movlw    0x00
	  movwf	   GPIO

ciclo     btfsc     pulsador  ;pregunta estado del pulsador
          goto      ciclo     ;no est oprimido vuelve a preguntar
          call	    retardito
          btfsc     pulsador  ;pregunta estado del pulsador
          goto      ciclo     ;no est oprimido vuelve a preguntar
          
          bcf       GPIO,1          
	      bsf       GPIO,0    ;si est oprimido enciende el LED
          nop
          
ciclo2	  btfsc     pulsador  ;pregunta estado del pulsador
          goto      ciclo2     ;no est oprimido vuelve a preguntar
		  call		retardito
          btfsc     pulsador  ;pregunta estado del pulsador
          goto      ciclo2     ;no est oprimido vuelve a preguntar
          
          bcf	    GPIO,0
	      nop
          bsf	    GPIO,1
          goto      ciclo     ;vuelve a probar estado del pulsador

;-------------------------------
retardo		;rutina de retardo de 1 segundo
	    movlw	D'6'
		movwf	x3
		movlw	D'24'
		movwf	x2
		movlw	D'168'
		movwf	x1
loop	decfsz	x1,1
		goto	loop
		decfsz	x2,1
		goto	loop
		decfsz	x3,1
		goto	loop
		retlw	0
;------------------------------
retardito
          movlw     D'100'    ;el registro loops contiene el nmero
          movwf     loops     ;de milisegundos del retardo
top2      movlw     D'110'    ;
          movwf     loops2    ;
top       nop
          nop
          nop
          nop
          nop
          nop
          decfsz    loops2    ;pregunta si termino 1 ms
          goto      top
          decfsz    loops     ;pregunta si termina el retardo
          goto      top2
          retlw     0

          end
